#include <misc.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#NoTrayIcon

Opt("TrayMenuMode",1)

$Abmessungen = 300
$AbmessungenTrap = $Abmessungen
$HoverBereich = $AbmessungenTrap / 3
$Aktiv = 1
$Background_Transparenz = 80 ;Max 255
$Feld_Transparenz = 220 ;Max 255
$Pfeil_Transparenz = 80 ;Max 255
$StartTime = IniRead(@ScriptDir & "\settings.ini", "Einstellungen", "Zeit", "500") ;Zeit, die die rechte Maustaste gehalten werden muss (Millisekunden)
$Show = False
$OldTime = 0

Dim $IconFeld[1]
Dim $Label[1]
Dim $HoverFeld[1]
Dim $FeldAktiv[1]
Dim $FeldPic[1]
Dim $FeldBgPic[1]
Dim $EditProgram[9]

$TrayShow= TrayCreateItem("Anzeigen")
$TraySettings = TrayCreateItem("Einstellungen")
TrayCreateItem("")
$TrayExit = TrayCreateItem("Beenden")

TraySetState()


$SettingsGUI = GUICreate("Einstellungen", 258, 345, -1, -1, 0x80880000, 0x00000088)
GUICtrlCreateLabel("Einstellungen", 16, 8, 90, 24)
GUICtrlSetFont(-1, 12, 800, 0, "Arial Narrow")
GUICtrlSetColor(-1, 0x000000)
$EditProgram[0] = GUICtrlCreateButton("NICHT BELEEGT", 16, 40, 73, 73, $BS_MULTILINE)
$EditProgram[1] = GUICtrlCreateButton("NICHT BELEEGT", 88, 40, 73, 73, $BS_MULTILINE)
$EditProgram[2] = GUICtrlCreateButton("NICHT BELEEGT", 160, 40, 73, 73, $BS_MULTILINE)
$EditProgram[3] = GUICtrlCreateButton("NICHT BELEEGT", 16, 112, 73, 73, $BS_MULTILINE)
$EditProgram[5] = GUICtrlCreateButton("NICHT BELEEGT", 160, 112, 73, 73, $BS_MULTILINE)
$EditProgram[6] = GUICtrlCreateButton("NICHT BELEEGT", 16, 184, 73, 73, $BS_MULTILINE)
$EditProgram[7] = GUICtrlCreateButton("NICHT BELEEGT", 88, 184, 73, 73, $BS_MULTILINE)
$EditProgram[8] = GUICtrlCreateButton("NICHT BELEEGT", 160, 184, 73, 73, $BS_MULTILINE)
GUICtrlCreateLabel("Dauer, bis startet:", 8, 264, 87, 17)
GUICtrlSetFont(-1, 8, 800, 0, "Arial")
$EditTimeSlider = GUICtrlCreateSlider(0, 280, 177, 33)
GUICtrlSetLimit(-1, 30, 2)
GUICtrlSetData(-1, $StartTime / 100)
$EditTimeLabel = GUICtrlCreateLabel("Sekunden", 180, 288, 71, 17)
GUICtrlSetFont(-1, 8, 800, 0, "Arial")
$SettingsOK = GUICtrlCreateButton("OK", 176, 320, 75, 17)
$SettingsCancel = GUICtrlCreateButton("Abbrechen", 96, 320, 75, 17)


$EditProgramGUI = GUICreate("Feld Bearbeiten", 330, 217, -1, -1, 0x80880000, 0x00000088)
GUICtrlCreateLabel("Feld Bearbeiten", 8, 8, 101, 24)
GUICtrlSetFont(-1, 12, 800, 0, "Arial Narrow")
GUICtrlCreateLabel("Bild", 8, 48, 24, 18)
GUICtrlSetFont(-1, 8, 800, 0, "Arial")
$EditPic = GUICtrlCreatePic(@ScriptDir & "\images\cross.jpg", 8, 64, 90, 90)
$EditPicInput = GUICtrlCreateInput("", -100, -100, 0, 0)
$EditPicSearch = GUICtrlCreateButton("Durchsuchen....", 8, 160, 91, 17)
GUICtrlCreateLabel("Name", 112,48, 35, 18)
GUICtrlSetFont(-1, 8, 800, 0, "Arial")
$EditNameInput = GUICtrlCreateInput("", 112, 64, 113, 21)
GUICtrlSetLimit(-1, 15)
GUICtrlCreateLabel("Aktion", 112, 96, 40, 18)
GUICtrlSetFont(-1, 8, 800, 0, "Arial")
$EditActionInput = GUICtrlCreateInput("", 112, 136, 209, 21)
$EditActionSearch = GUICtrlCreateButton("Durchsuchen...", 224, 160, 97, 17)
$EditActionRadioProgram = GUICtrlCreateRadio("Programm", 112, 112, 70, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
$EditActionRadioHP= GUICtrlCreateRadio("Homepage", 186, 112, 113, 17)
$EditProgramDelete = GUICtrlCreateButton("Entfernen", 80, 192, 73, 17)
$EditProgramOK = GUICtrlCreateButton("OK", 240, 192, 81, 17)
$EditProgramCancel = GUICtrlCreateButton("Abbrechen", 160, 192, 75, 17)


$BackgroundGUI = GUICreate("", @DesktopWidth + 10, @DesktopHeight + 10, -5, -5, 0x80880000, 0x00000088)
GUISetBkColor(0x000000)
WinSetTrans($BackgroundGUI,"", $Background_Transparenz)


$HelpGUI = GUICreate("", 300, 20, 0, 0, 0x80880000, 0x00000088)
GUISetBkColor(0xFFFFFF)
GUICtrlCreateLabel("Einstellungen: F1 Taste!", 5, 3)
WinSetTrans($HelpGUI,"",255)

$GUI = GUICreate("", $Abmessungen, $Abmessungen, _
				@DesktopWidth/2 - $Abmessungen/2 - 1, _
				@DesktopHeight/2 - $Abmessungen/2 - 1, _
				0x80880000, 0x00000088)
WinSetTrans($GUI,"",0)

$pos = WinGetPos($GUI)

$FeldNummer = 0

For $Y_Position = 0 To 2
	For $X_Position = 0 To 2
		ReDim $IconFeld[$FeldNummer + 1]
		ReDim $Label[$FeldNummer + 1]
		ReDim $FeldPic[$FeldNummer + 1]
		ReDim $FeldBgPic[$FeldNummer + 1]
		$IconFeld[$FeldNummer] = GUICreate("icon" & $FeldNummer, $HoverBereich-2, $HoverBereich-2, _
										$pos[0] + $HoverBereich * $X_Position, _
										$pos[1] + $HoverBereich * $Y_Position, _
										0x80880000, 0x00000088)

		GUISetBkColor(0xd1d1d2)
		GUISetCursor(16, 1)
		$FeldBgPic[$FeldNummer] = GUICtrlCreatePic(@ScriptDir & "\images\normal.jpg", 0, 0, $HoverBereich-2, $HoverBereich-2)
		GUICtrlSetState(-1, $GUI_DISABLE)
		If $FeldNummer <> 4 Then
			$Text = IniRead(@ScriptDir & "\settings.ini", $FeldNummer, "Text", "")
			If $FeldNummer <> 4 Then $Label[$FeldNummer] = GUICtrlCreateLabel($Text, 0, $HoverBereich - $AbmessungenTrap/15, $HoverBereich, $AbmessungenTrap/15, $SS_CENTER & $GUI_BKCOLOR_TRANSPARENT)
			GUICtrlSetFont(-1, $AbmessungenTrap/33, 400, 0, "Arial Narrow")
			GUICtrlSetColor(-1, 0x000000)

			$BildAbmessungen = $HoverBereich / 1.5
			$Bild = IniRead(@ScriptDir & "\settings.ini", $FeldNummer, "Bild", @ScriptDir & "\images\default.jpg")
			$FeldPic[$FeldNummer] = GUICtrlCreatePic($Bild,($HoverBereich - $BildAbmessungen) / 2, ($HoverBereich - $BildAbmessungen) / 3, $BildAbmessungen, $BildAbmessungen)
			WinSetTrans($IconFeld[$FeldNummer],"", $Feld_Transparenz)
		Else
			$PfeilBild = GUICtrlCreatePic(@ScriptDir & "\images\1.jpg", 0, 0, $HoverBereich, $HoverBereich)

			WinSetTrans($IconFeld[$FeldNummer],"", $Pfeil_Transparenz)
		EndIf

		$FeldNummer += 1
	Next
Next

$FeldNummer = 0

For $Y_Position = 0 To 2
	For $X_Position = 0 To 2
		ReDim $HoverFeld[$FeldNummer + 1]
		$HoverFeld[$FeldNummer] = GUICreate("hover" & $FeldNummer,$HoverBereich / 3, _
												$HoverBereich / 3, _
												$pos[0] + $HoverBereich / 3 * $X_Position + $HoverBereich -2, _
												$pos[1] + $HoverBereich / 3 * $Y_Position + $HoverBereich -2, _
												0x80880000, 0x00000088)
		WinSetTrans($HoverFeld[$FeldNummer],"",0)
		$FeldNummer += 1
	Next
Next

ReDim $FeldAktiv[$FeldNummer]
For $i = 0 To $FeldNummer-1
	$FeldAktiv[$i] = "False"
	If $i = 4 Then $FeldAktiv[$i] = "True"
Next

While Sleep(10)
	$tMsg = TrayGetMsg()
	Switch $tMsg
		Case $TrayShow
			_ShowHideAll(1)
		Case $TraySettings
			_ShowHideAll(1)
			_ShowHideAll()
			_SettingsLoad()
		Case $TrayExit
			_Exit()
	EndSwitch
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $SettingsCancel
			GUISetState(@SW_HIDE, $SettingsGUI)
			GUISetState(@SW_HIDE, $EditProgramGUI)
			_ShowHideAll()
		Case $SettingsOK
			IniWrite(@ScriptDir & "\settings.ini", "Einstellungen", "Zeit", GUICtrlRead($EditTimeSlider) * 100)
			$StartTime = GUICtrlRead($EditTimeSlider) * 100
			GUISetState(@SW_HIDE, $SettingsGUI)
			GUISetState(@SW_HIDE, $EditProgramGUI)
			_ShowHideAll()
		Case $EditProgram[0]
			_EditFieldLoad(0)
		Case $EditProgram[1]
			_EditFieldLoad(1)
		Case $EditProgram[2]
			_EditFieldLoad(2)
		Case $EditProgram[3]
			_EditFieldLoad(3)
		Case $EditProgram[5]
			_EditFieldLoad(5)
		Case $EditProgram[6]
			_EditFieldLoad(6)
		Case $EditProgram[7]
			_EditFieldLoad(7)
		Case $EditProgram[8]
			_EditFieldLoad(8)
		Case $EditPicSearch
			_HideBackground()
			_MouseTrap()
			GUISetState(@SW_HIDE, $EditProgramGUI)
			GUISetState(@SW_HIDE, $SettingsGUI)
			$Pic = FileOpenDialog("Bild suchen...", "", "Bilder (*.jpg;*.bmp;*.gif)")
			_ShowBackground()
			GUISetState(@SW_SHOW, $EditProgramGUI)
			GUISetState(@SW_SHOW, $SettingsGUI)
			WinActivate($SettingsGUI)
			WinActivate($EditProgramGUI)
			$EditProgramPos = WinGetPos($EditProgramGUI)
			_MouseTrap($EditProgramPos[0], $EditProgramPos[1], $EditProgramPos[0] + $EditProgramPos[2], $EditProgramPos[1] + $EditProgramPos[3])
			GUICtrlSetImage($EditPic, $Pic)
			GUICtrlSetImage($EditPic, $Pic)
			GUICtrlSetData($EditPicInput, $Pic)


		Case $EditActionRadioProgram
			If BitAND(GUICtrlRead($EditActionRadioProgram), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlSetState($EditActionSearch, $GUI_ENABLE)
			Else
				GUICtrlSetState($EditActionSearch, $GUI_DISABLE)
			EndIf
		Case $EditActionRadioHP
			If BitAND(GUICtrlRead($EditActionRadioProgram), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlSetState($EditActionSearch, $GUI_ENABLE)
			Else
				GUICtrlSetState($EditActionSearch, $GUI_DISABLE)
			EndIf
		Case $EditActionSearch
			_HideBackground()
			_MouseTrap()
			GUISetState(@SW_HIDE, $EditProgramGUI)
			GUISetState(@SW_HIDE, $SettingsGUI)
			$ActionPath = FileOpenDialog("Programm/Datei suchen...", "", "Alle Dateien (*.*)")
			_ShowBackground()
			GUISetState(@SW_SHOW, $EditProgramGUI)
			GUISetState(@SW_SHOW, $SettingsGUI)
			WinActivate($SettingsGUI)
			WinActivate($EditProgramGUI)
			$EditProgramPos = WinGetPos($EditProgramGUI)
			_MouseTrap($EditProgramPos[0], $EditProgramPos[1], $EditProgramPos[0] + $EditProgramPos[2], $EditProgramPos[1] + $EditProgramPos[3])
			GUICtrlSetData($EditActionInput, $ActionPath)

		Case $EditProgramOK
			IniWrite(@ScriptDir & "\settings.ini", WinGetTitle($EditProgramGUI), "Bild", GUICtrlRead($EditPicInput))
			GUICtrlSetImage($FeldPic[WinGetTitle($EditProgramGUI)],GUICtrlRead($EditPicInput))
			IniWrite(@ScriptDir & "\settings.ini", WinGetTitle($EditProgramGUI), "Text", GUICtrlRead($EditNameInput))
			GUICtrlSetData($Label[WinGetTitle($EditProgramGUI)], GUICtrlRead($EditNameInput))
			GUICtrlSetData($EditProgram[WinGetTitle($EditProgramGUI)], GUICtrlRead($EditNameInput))
			IniWrite(@ScriptDir & "\settings.ini", WinGetTitle($EditProgramGUI), "Aktion", GUICtrlRead($EditActionInput))
			If BitAND(GUICtrlRead($EditActionRadioProgram), $GUI_CHECKED) = $GUI_CHECKED Then
				IniWrite(@ScriptDir & "\settings.ini", WinGetTitle($EditProgramGUI), "Typ", "Programm")
			Else
				IniWrite(@ScriptDir & "\settings.ini", WinGetTitle($EditProgramGUI), "Typ", "Homepage")
			EndIf
			GUISetState(@SW_HIDE, $EditProgramGUI)
			$SettingsPos = WinGetPos($SettingsGUI)
			_MouseTrap($SettingsPos[0], $SettingsPos[1], $SettingsPos[0] + $SettingsPos[2], $SettingsPos[1] + $SettingsPos[3])
		Case $EditProgramDelete
			IniDelete(@ScriptDir & "\settings.ini", WinGetTitle($EditProgramGUI))
			_SettingsLoad()
			_EditFieldLoad(WinGetTitle($EditProgramGUI))
		Case $EditProgramCancel
			GUISetState(@SW_HIDE, $EditProgramGUI)
			_SettingsLoad()
			GUISetState(@SW_SHOW, $SettingsGUI)
			WinActivate($SettingsGUI)
	EndSwitch

;~ 	If _IsPressed(20) Then ;SPACE
;~ 		_Exit()
;~ 	EndIf

;~ 	If _IsPressed("1B") Then ;ESC
;~ 		_Exit()
;~ 	EndIf

	If $Show = True Then
		If _IsPressed(70) Then ;F1
			While _IsPressed(70)
				If WinActive($SettingsGUI) Or WinActive($EditProgramGUI) Then
					GUISetState(@SW_HIDE, $SettingsGUI)
					GUISetState(@SW_HIDE, $EditProgramGUI)
					ExitLoop
				Else
					_ShowHideAll()
					_SettingsLoad()
					ExitLoop
				EndIf
				Sleep(40)
			WEnd
			While _IsPressed(70)
				Sleep(40)
			WEnd
		EndIf
		_Feld()
	EndIf

	If _IsPressed(02) And WinActive($SettingsGUI) = False And WinActive($EditProgramGUI) = False Then ;Rechte Maustaste
		$PressedTime = TimerInit()
		While _IsPressed(02)
			If TimerDiff($PressedTime) >= $StartTime Then
				_ShowHideAll(1)
				ExitLoop
			EndIf
			Sleep(40)
		WEnd
		While _IsPressed(02)
			Sleep(40)
		WEnd

	EndIf

	If WinActive($SettingsGUI) And GUICtrlRead($EditTimeSlider) <> $OldTime Then
		GUICtrlSetData($EditTimeLabel, GUICtrlRead($EditTimeSlider) * 0.1 & "Sekunden")
		$OldTime = GUICtrlRead($EditTimeSlider)
	EndIf



	If _IsPressed(01) And $Show = True Then
		_StartProgram(_Feld())
	EndIf

WEnd

Func _ShowHideAll($BG = "")
	If $Show = False Then
		GUISetState(@SW_SHOW, $GUI)
		If $BG = 1 Then _ShowBackground()
		For $i = 0 To 8
			GUISetState(@SW_SHOW, $IconFeld[$i])
			GUISetState(@SW_SHOW, $HoverFeld[$i])
		Next
		$pos = WinGetPos($GUI)

		_MouseTrap($pos[0] + $HoverBereich + 1, _
				$pos[1] + $HoverBereich + 1, _
				$pos[0] + $HoverBereich * 2 - 1, _
				$pos[1] + $HoverBereich * 2 - 1)

		$Show = True
	Else
		GUISetState(@SW_HIDE, $GUI)
		If $BG = 1 Then _HideBackground()
		For $i = 0 To 8
			GUISetState(@SW_HIDE, $IconFeld[$i])
			GUISetState(@SW_HIDE, $HoverFeld[$i])
		Next
		_MouseTrap()
		$Show = False
	EndIf
EndFunc

Func _ShowBackground()
		GUISetState(@SW_SHOW, $BackgroundGUI)
		GUISetState(@SW_SHOW, $HelpGUI)
EndFunc

Func _HideBackground()
		GUISetState(@SW_HIDE, $BackgroundGUI)
		GUISetState(@SW_HIDE, $HelpGUI)
EndFunc


Func _Feld()
	For $i = 0 To UBound($HoverFeld)-1
		If $i <> 4 Then
			$pos = GUIGetCursorInfo(WinGetHandle("hover" & $i))
			If $pos[0] <= $HoverBereich / 3 And $pos[1] <= $HoverBereich / 3 And $pos[0] >= 1 / 3 And $pos[1] >= 1 Then
				$Aktiv = $i
				If $FeldAktiv[$i] = "False" Then
					GUISetBkColor(0x404041, WinGetHandle("icon" & $Aktiv))
					GUICtrlSetImage($PfeilBild, @ScriptDir & "\images\" & $Aktiv & ".jpg")
					GUICtrlSetImage($FeldBgPic[$Aktiv], @ScriptDir & "\images\hover.jpg")
				EndIf
				$FeldAktiv[$i] = "True"
			Else
				For $i2 = 0 To UBound($HoverFeld)-1
					If $FeldAktiv[$i2] = "True" Then
						If $i2 <> $Aktiv Then
							GUISetBkColor(0xd1d1d2, WinGetHandle("icon" & $i2))
							GUICtrlSetImage($FeldBgPic[$i2], @ScriptDir & "\images\normal.jpg")
							$FeldAktiv[$i2] = "False"
						EndIf
					EndIf
				Next
			EndIf
		EndIf
	Next
	Return $Aktiv
EndFunc

Func _SettingsLoad()
	For $i = 0 To 8
		GUICtrlSetData($EditProgram[$i], IniRead(@ScriptDir & "\settings.ini", $i, "Text", "NICHT BELEEGT"))
	Next
	GUISetState(@SW_SHOW, $SettingsGUI)
	WinActivate($SettingsGUI)
	$SettingsPos = WinGetPos($SettingsGUI)
	_MouseTrap($SettingsPos[0], $SettingsPos[1], $SettingsPos[0] + $SettingsPos[2], $SettingsPos[1] + $SettingsPos[3])
EndFunc

Func _EditFieldLoad($EditProgramAktiv)
	WinSetTitle($EditProgramGUI, "", $EditProgramAktiv)
	GUICtrlSetImage($EditPic, IniRead(@ScriptDir & "\settings.ini", $EditProgramAktiv, "Bild", @ScriptDir & "\images\cross.jpg"))
	GUICtrlSetData($EditPicInput, IniRead(@ScriptDir & "\settings.ini", $EditProgramAktiv, "Bild", @ScriptDir & "\images\cross.jpg"))
	GUICtrlSetData($EditNameInput, IniRead(@ScriptDir & "\settings.ini", $EditProgramAktiv, "Text", ""))
	GUICtrlSetData($EditActionInput, IniRead(@ScriptDir & "\settings.ini", $EditProgramAktiv, "Aktion", ""))
	If IniRead(@ScriptDir & "\settings.ini", $EditProgramAktiv, "Typ", "Programm") = "Programm" Then
		GUICtrlSetState($EditActionRadioProgram, $GUI_CHECKED)
		GUICtrlSetState($EditActionRadioHP, $GUI_UNCHECKED)
	Else
		GUICtrlSetState($EditActionRadioProgram, $GUI_UNCHECKED)
		GUICtrlSetState($EditActionRadioHP, $GUI_CHECKED)
	EndIf
	GUISetState(@SW_SHOW, $EditProgramGUI)
	WinActivate($EditProgramGUI)
	$EditProgramPos = WinGetPos($EditProgramGUI)
	_MouseTrap($EditProgramPos[0], $EditProgramPos[1], $EditProgramPos[0] + $EditProgramPos[2], $EditProgramPos[1] + $EditProgramPos[3])
EndFunc

Func _StartProgram($AktivGeklickt)
	$Execute = IniRead(@ScriptDir & "\settings.ini", $AktivGeklickt, "Aktion", "")
	If $Execute <> "" Then ShellExecute($Execute)
	_ShowHideAll(1)
;~ 	_Exit()
EndFunc

Func _Exit()
	_MouseTrap()
	Exit
EndFunc